#ifndef __TICTACTOE_H
    #define __TICTACTOE_H

    #include<iostream>
    #include "combinatorialgame.h"

    class TicTacToe : public AlgorithMan::CombinatorialGame
    {
        public:
            TicTacToe();
            ~TicTacToe();

            AlgorithMan::CombinatorialGamePosition* InitialPosition();
    };

    class TicTacToePosition : public AlgorithMan::CombinatorialGamePosition
    {
        friend class TicTacToe;
        protected:
            int field[3][3];
            int fieldspicked;

            TicTacToePosition();
            TicTacToePosition(const TicTacToePosition& copy);
            void WriteToStream(std::ostream& os) const;

        public:
            ~TicTacToePosition();

            int PlayersTurn();
            int PlayerWon();
            std::set<AlgorithMan::CombinatorialGamePosition*> PossibleMoves();
    };

#endif
